theory Temporal imports pGCL pVCG begin

definition
  oneStep :: "('s \<Rightarrow> bool) \<Rightarrow> 's prog \<Rightarrow> 's \<Rightarrow> real"
where
  "oneStep P a = wp a \<guillemotleft>P\<guillemotright>"

definition
  eventually :: "('s \<Rightarrow> bool) \<Rightarrow> 's prog \<Rightarrow> 's \<Rightarrow> real"
where
  "eventually P a = wp (do \<^boverline>P\<^eoverline> \<longrightarrow> a od) (\<lambda>s. 1)"

definition
  forever :: "('s \<Rightarrow> bool) \<Rightarrow> 's prog \<Rightarrow> 's \<Rightarrow> real"
where
  "forever P a = wlp (do P \<longrightarrow> a od) (\<lambda>s. 0)"

lemma loop_have_guard:
  "wp (do G \<longrightarrow> a od) P = wp (do G \<longrightarrow> a od) (P && \<guillemotleft>\<^boverline>G\<^eoverline>\<guillemotright>)"
  unfolding wp_eval
proof(rule antisym)

lemma
  "oneStep P a \<tturnstile> eventually P a"
  unfolding oneStep_def eventually_def
  unfolding wp_eval
thm le_transD
thm lfp_trans_greatest
  apply(rule lfp_trans_greatest)
  apply(pvcg)
