(*
 * Copyright (C) 2013 National ICT Australia Ltd ('NICTA')
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *)

(* Author: David Cock - David.Cock@nicta.com.au *)

header "The (probabilistic) Verification Condition Generator"

theory pVCG imports pGCL
uses("pVCG.ML")
begin

use "pVCG.ML"

setup pVCG.setup

method_setup pvcg =
  {* Scan.succeed (fn ctxt => SIMPLE_METHOD' (pVCG.pVCG_tac ctxt)) *}
  "Probabilistic weakest preexpectation tactic"

declare healthy_intros[health]

declare wp_Seq[wp_core] wp_Skip[wp_core] wp_Apply[wp_core] wp_DC[wp_core]
declare wlp_Seq[wp_core] wlp_Skip[wp_core] wlp_Apply[wp_core] wlp_DC[wp_core]
declare wp_SetPC[wp_core]

end
